<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.15"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>AlexaClientSDK: /workplace/avs-device-sdk/AVSCommon/Utils/src/LibcurlUtils/LibCurlHttpContentFetcher.cpp File Reference</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectlogo"><img alt="Logo" src="avs-logo.png"/></td>
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">AlexaClientSDK
   &#160;<span id="projectnumber">1.13.0</span>
   </div>
   <div id="projectbrief">A cross-platform, modular SDK for interacting with the Alexa Voice Service</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.15 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'Search');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div id="nav-path" class="navpath">
  <ul>
<li class="navelem"><a class="el" href="dir_13e65effb2bde530b17b3d5eefcd0266.html">AVSCommon</a></li><li class="navelem"><a class="el" href="dir_49dd3d9ac5586189aa170bac46425b9c.html">Utils</a></li><li class="navelem"><a class="el" href="dir_93a54634d0ab52618b36b15672961616.html">src</a></li><li class="navelem"><a class="el" href="dir_8c36055f000274ee212dc5eb2574a4ea.html">LibcurlUtils</a></li>  </ul>
</div>
</div><!-- top -->
<div class="header">
  <div class="summary">
<a href="#namespaces">Namespaces</a> &#124;
<a href="#define-members">Macros</a> &#124;
<a href="#func-members">Functions</a> &#124;
<a href="#var-members">Variables</a>  </div>
  <div class="headertitle">
<div class="title">LibCurlHttpContentFetcher.cpp File Reference</div>  </div>
</div><!--header-->
<div class="contents">
<div class="textblock"><code>#include &lt;algorithm&gt;</code><br />
<code>#include &lt;chrono&gt;</code><br />
<code>#include &lt;<a class="el" href="_h_t_t_p_content_fetcher_interface_8h_source.html">AVSCommon/SDKInterfaces/HTTPContentFetcherInterface.h</a>&gt;</code><br />
<code>#include &lt;<a class="el" href="_http_response_code_8h_source.html">AVSCommon/Utils/HTTP/HttpResponseCode.h</a>&gt;</code><br />
<code>#include &lt;<a class="el" href="_curl_easy_handle_wrapper_8h_source.html">AVSCommon/Utils/LibcurlUtils/CurlEasyHandleWrapper.h</a>&gt;</code><br />
<code>#include &quot;<a class="el" href="_curl_multi_handle_wrapper_8h_source.html">AVSCommon/Utils/LibcurlUtils/CurlMultiHandleWrapper.h</a>&quot;</code><br />
<code>#include &lt;<a class="el" href="_lib_curl_http_content_fetcher_8h_source.html">AVSCommon/Utils/LibcurlUtils/LibCurlHttpContentFetcher.h</a>&gt;</code><br />
<code>#include &lt;<a class="el" href="_memory_8h_source.html">AVSCommon/Utils/Memory/Memory.h</a>&gt;</code><br />
<code>#include &lt;<a class="el" href="_in_process_s_d_s_8h_source.html">AVSCommon/Utils/SDS/InProcessSDS.h</a>&gt;</code><br />
</div><div class="textblock"><div class="dynheader">
Include dependency graph for LibCurlHttpContentFetcher.cpp:</div>
<div class="dyncontent">
<div class="center"><img src="_lib_curl_http_content_fetcher_8cpp__incl.png" border="0" usemap="#_2workplace_2avs-device-sdk_2_a_v_s_common_2_utils_2src_2_libcurl_utils_2_lib_curl_http_content_fetcher_8cpp" alt=""/></div>
<map name="_2workplace_2avs-device-sdk_2_a_v_s_common_2_utils_2src_2_libcurl_utils_2_lib_curl_http_content_fetcher_8cpp" id="_2workplace_2avs-device-sdk_2_a_v_s_common_2_utils_2src_2_libcurl_utils_2_lib_curl_http_content_fetcher_8cpp">
<area shape="rect" id="node4" href="_h_t_t_p_content_fetcher_interface_8h.html" title="AVSCommon/SDKInterfaces\l/HTTPContentFetcherInterface.h" alt="" coords="2406,205,2621,244"/>
<area shape="rect" id="node6" href="_http_response_code_8h.html" title="AVSCommon/Utils/HTTP\l/HttpResponseCode.h" alt="" coords="1981,699,2150,737"/>
<area shape="rect" id="node30" href="_in_process_s_d_s_8h.html" title="AVSCommon/Utils/SDS\l/InProcessSDS.h" alt="" coords="790,539,952,577"/>
<area shape="rect" id="node43" href="_curl_easy_handle_wrapper_8h.html" title="AVSCommon/Utils/LibcurlUtils\l/CurlEasyHandleWrapper.h" alt="" coords="2560,699,2760,737"/>
<area shape="rect" id="node45" href="_curl_multi_handle_wrapper_8h.html" title="AVSCommon/Utils/LibcurlUtils\l/CurlMultiHandleWrapper.h" alt="" coords="2936,699,3136,737"/>
<area shape="rect" id="node47" href="_lib_curl_http_content_fetcher_8h.html" title="AVSCommon/Utils/LibcurlUtils\l/LibCurlHttpContentFetcher.h" alt="" coords="2559,119,2758,157"/>
<area shape="rect" id="node49" href="_memory_8h.html" title="AVSCommon/Utils/Memory\l/Memory.h" alt="" coords="3017,119,3199,157"/>
<area shape="rect" id="node24" href="_h_t_t_p_content_8h.html" title="AVSCommon/Utils/HTTPContent.h" alt="" coords="2292,292,2519,317"/>
<area shape="rect" id="node42" href="_s_d_k_version_8h.html" title="AVSCommon/Utils/SDKVersion.h" alt="" coords="2491,545,2709,571"/>
<area shape="rect" id="node9" href="_logger_utils_8h.html" title="AVSCommon/Utils/Logger\l/LoggerUtils.h" alt="" coords="1120,785,1296,824"/>
<area shape="rect" id="node10" href="_logger_8h.html" title="AVSCommon/Utils/Logger\l/Logger.h" alt="" coords="1669,872,1845,911"/>
<area shape="rect" id="node15" href="_configuration_node_8h.html" title="AVSCommon/Utils/Configuration\l/ConfigurationNode.h" alt="" coords="1128,959,1342,997"/>
<area shape="rect" id="node17" href="_level_8h.html" title="AVSCommon/Utils/Logger\l/Level.h" alt="" coords="1867,1045,2043,1084"/>
<area shape="rect" id="node18" href="_log_entry_8h.html" title="AVSCommon/Utils/Logger\l/LogEntry.h" alt="" coords="2229,959,2405,997"/>
<area shape="rect" id="node22" href="_log_level_observer_interface_8h.html" title="AVSCommon/Utils/Logger\l/LogLevelObserverInterface.h" alt="" coords="1720,959,1917,997"/>
<area shape="rect" id="node23" href="_sink_observer_interface_8h.html" title="AVSCommon/Utils/Logger\l/SinkObserverInterface.h" alt="" coords="1873,1132,2049,1171"/>
<area shape="rect" id="node19" href="_log_entry_stream_8h.html" title="AVSCommon/Utils/Logger\l/LogEntryStream.h" alt="" coords="1283,1045,1459,1084"/>
<area shape="rect" id="node21" href="_log_entry_buffer_8h.html" title="AVSCommon/Utils/Logger\l/LogEntryBuffer.h" alt="" coords="1283,1132,1459,1171"/>
<area shape="rect" id="node26" href="_in_process_attachment_8h.html" title="AVSCommon/AVS/Attachment\l/InProcessAttachment.h" alt="" coords="1049,365,1250,404"/>
<area shape="rect" id="node27" href="_attachment_8h.html" title="AVSCommon/AVS/Attachment\l/Attachment.h" alt="" coords="1277,452,1478,491"/>
<area shape="rect" id="node40" href="_in_process_attachment_reader_8h.html" title="AVSCommon/AVS/Attachment\l/InProcessAttachmentReader.h" alt="" coords="1046,452,1252,491"/>
<area shape="rect" id="node41" href="_in_process_attachment_writer_8h.html" title="AVSCommon/AVS/Attachment\l/InProcessAttachmentWriter.h" alt="" coords="770,452,971,491"/>
<area shape="rect" id="node28" href="_attachment_reader_8h.html" title="AVSCommon/AVS/Attachment\l/AttachmentReader.h" alt="" coords="1427,699,1629,737"/>
<area shape="rect" id="node29" href="_reader_policy_8h.html" title="AVSCommon/Utils/SDS\l/ReaderPolicy.h" alt="" coords="1320,785,1482,824"/>
<area shape="rect" id="node39" href="_writer_policy_8h.html" title="WriterPolicy.h" alt="" coords="943,792,1046,817"/>
<area shape="rect" id="node32" href="_shared_data_stream_8h.html" title="SharedDataStream.h" alt="" coords="495,625,641,651"/>
<area shape="rect" id="node34" href="_buffer_layout_8h.html" title="BufferLayout.h" alt="" coords="514,705,622,731"/>
<area shape="rect" id="node35" href="_reader_8h.html" title="Reader.h" alt="" coords="666,705,742,731"/>
<area shape="rect" id="node38" href="_writer_8h.html" title="Writer.h" alt="" coords="325,705,392,731"/>
</map>
</div>
</div><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="namespaces"></a>
Namespaces</h2></td></tr>
<tr class="memitem:namespacealexa_client_s_d_k"><td class="memItemLeft" align="right" valign="top"> &#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="namespacealexa_client_s_d_k.html">alexaClientSDK</a></td></tr>
<tr class="memdesc:namespacealexa_client_s_d_k"><td class="mdescLeft">&#160;</td><td class="mdescRight">Whether or not curl logs should be emitted. <br /></td></tr>
<tr class="separator:"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:namespacealexa_client_s_d_k_1_1avs_common"><td class="memItemLeft" align="right" valign="top"> &#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="namespacealexa_client_s_d_k_1_1avs_common.html">alexaClientSDK::avsCommon</a></td></tr>
<tr class="separator:"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:namespacealexa_client_s_d_k_1_1avs_common_1_1utils"><td class="memItemLeft" align="right" valign="top"> &#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="namespacealexa_client_s_d_k_1_1avs_common_1_1utils.html">alexaClientSDK::avsCommon::utils</a></td></tr>
<tr class="separator:"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:namespacealexa_client_s_d_k_1_1avs_common_1_1utils_1_1libcurl_utils"><td class="memItemLeft" align="right" valign="top"> &#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="namespacealexa_client_s_d_k_1_1avs_common_1_1utils_1_1libcurl_utils.html">alexaClientSDK::avsCommon::utils::libcurlUtils</a></td></tr>
<tr class="separator:"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="define-members"></a>
Macros</h2></td></tr>
<tr class="memitem:ad8bc9ca8e55a0ebf538e46e28bf26262"><td class="memItemLeft" align="right" valign="top">#define&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="_lib_curl_http_content_fetcher_8cpp.html#ad8bc9ca8e55a0ebf538e46e28bf26262">LX</a>(event)&#160;&#160;&#160;<a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1logger_1_1_log_entry.html">alexaClientSDK::avsCommon::utils::logger::LogEntry</a>(<a class="el" href="_u_i_manager_8cpp.html#ada5473a95becdcf63a8f83e7f05fefe7">TAG</a>, event)</td></tr>
<tr class="separator:ad8bc9ca8e55a0ebf538e46e28bf26262"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="func-members"></a>
Functions</h2></td></tr>
<tr class="memitem:a3edac8fd6ed5516bac879dfbcd8217c2"><td class="memItemLeft" align="right" valign="top">static const std::string&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="namespacealexa_client_s_d_k_1_1avs_common_1_1utils_1_1libcurl_utils.html#a3edac8fd6ed5516bac879dfbcd8217c2">alexaClientSDK::avsCommon::utils::libcurlUtils::TAG</a> (&quot;LibCurlHttpContentFetcher&quot;)</td></tr>
<tr class="memdesc:a3edac8fd6ed5516bac879dfbcd8217c2"><td class="mdescLeft">&#160;</td><td class="mdescRight">String to identify log entries originating from this file.  <a href="namespacealexa_client_s_d_k_1_1avs_common_1_1utils_1_1libcurl_utils.html#a3edac8fd6ed5516bac879dfbcd8217c2">More...</a><br /></td></tr>
<tr class="separator:a3edac8fd6ed5516bac879dfbcd8217c2"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="var-members"></a>
Variables</h2></td></tr>
<tr class="memitem:a582c6c6e07d6472ad6164f369bfc5745"><td class="memItemLeft" align="right" valign="top">static const std::chrono::milliseconds&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="namespacealexa_client_s_d_k_1_1avs_common_1_1utils_1_1libcurl_utils.html#a582c6c6e07d6472ad6164f369bfc5745">alexaClientSDK::avsCommon::utils::libcurlUtils::TIMEOUT_FOR_BLOCKING_WRITE</a> = std::chrono::milliseconds(100)</td></tr>
<tr class="separator:a582c6c6e07d6472ad6164f369bfc5745"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:aae322c113e9b928d6af66474f5a281e2"><td class="memItemLeft" align="right" valign="top">static const std::chrono::milliseconds&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="namespacealexa_client_s_d_k_1_1avs_common_1_1utils_1_1libcurl_utils.html#aae322c113e9b928d6af66474f5a281e2">alexaClientSDK::avsCommon::utils::libcurlUtils::WAIT_FOR_ACTIVITY_TIMEOUT</a> {100}</td></tr>
<tr class="memdesc:aae322c113e9b928d6af66474f5a281e2"><td class="mdescLeft">&#160;</td><td class="mdescRight">Timeout for polling loops that check activities running on separate threads.  <a href="namespacealexa_client_s_d_k_1_1avs_common_1_1utils_1_1libcurl_utils.html#aae322c113e9b928d6af66474f5a281e2">More...</a><br /></td></tr>
<tr class="separator:aae322c113e9b928d6af66474f5a281e2"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:aec2416d5a1025b96be723531fb5d92e8"><td class="memItemLeft" align="right" valign="top">static const auto&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="namespacealexa_client_s_d_k_1_1avs_common_1_1utils_1_1libcurl_utils.html#aec2416d5a1025b96be723531fb5d92e8">alexaClientSDK::avsCommon::utils::libcurlUtils::TIMEOUT_CONNECTION</a> = std::chrono::seconds(30)</td></tr>
<tr class="memdesc:aec2416d5a1025b96be723531fb5d92e8"><td class="mdescLeft">&#160;</td><td class="mdescRight">Timeout for curl connection.  <a href="namespacealexa_client_s_d_k_1_1avs_common_1_1utils_1_1libcurl_utils.html#aec2416d5a1025b96be723531fb5d92e8">More...</a><br /></td></tr>
<tr class="separator:aec2416d5a1025b96be723531fb5d92e8"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a3ca3604189ed467fad1ee766125257b3"><td class="memItemLeft" align="right" valign="top">static const std::chrono::minutes&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="namespacealexa_client_s_d_k_1_1avs_common_1_1utils_1_1libcurl_utils.html#a3ca3604189ed467fad1ee766125257b3">alexaClientSDK::avsCommon::utils::libcurlUtils::MAX_GET_BODY_WAIT</a> {1}</td></tr>
<tr class="memdesc:a3ca3604189ed467fad1ee766125257b3"><td class="mdescLeft">&#160;</td><td class="mdescRight">Timeout to wait for a call to get body after getContent was called.  <a href="namespacealexa_client_s_d_k_1_1avs_common_1_1utils_1_1libcurl_utils.html#a3ca3604189ed467fad1ee766125257b3">More...</a><br /></td></tr>
<tr class="separator:a3ca3604189ed467fad1ee766125257b3"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:aa144178293557a48cec87fd8a1eecfb1"><td class="memItemLeft" align="right" valign="top">static const std::chrono::minutes&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="namespacealexa_client_s_d_k_1_1avs_common_1_1utils_1_1libcurl_utils.html#aa144178293557a48cec87fd8a1eecfb1">alexaClientSDK::avsCommon::utils::libcurlUtils::MAX_GET_HEADER_WAIT</a> {5}</td></tr>
<tr class="memdesc:aa144178293557a48cec87fd8a1eecfb1"><td class="mdescLeft">&#160;</td><td class="mdescRight">Timeout to wait for get header to complete.  <a href="namespacealexa_client_s_d_k_1_1avs_common_1_1utils_1_1libcurl_utils.html#aa144178293557a48cec87fd8a1eecfb1">More...</a><br /></td></tr>
<tr class="separator:aa144178293557a48cec87fd8a1eecfb1"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table>
<h2 class="groupheader">Macro Definition Documentation</h2>
<a id="ad8bc9ca8e55a0ebf538e46e28bf26262"></a>
<h2 class="memtitle"><span class="permalink"><a href="#ad8bc9ca8e55a0ebf538e46e28bf26262">&#9670;&nbsp;</a></span>LX</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">#define LX</td>
          <td>(</td>
          <td class="paramtype">&#160;</td>
          <td class="paramname">event</td><td>)</td>
          <td>&#160;&#160;&#160;<a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1logger_1_1_log_entry.html">alexaClientSDK::avsCommon::utils::logger::LogEntry</a>(<a class="el" href="_u_i_manager_8cpp.html#ada5473a95becdcf63a8f83e7f05fefe7">TAG</a>, event)</td>
        </tr>
      </table>
</div><div class="memdoc">
<p class="">Create a LogEntry using this file's TAG and the specified event string.</p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">The</td><td>event string for this <code>LogEntry</code>. </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
</div><!-- contents -->
<html>
  <body>
    <p style="text-align:left;">
      AlexaClientSDK 1.13.0 - Copyright 2016-2019 Amazon.com, Inc. or its affiliates. All Rights Reserved.
      <span style="float:right;">
	Licensed under the <a HREF=http://aws.amazon.com/apache2.0/>Apache License, Version 2.0</a>
      </span>
    </p>
  </body>
</html>
